Import Trade Transactions into Supply Chain Financial Orchestration for Generating Intercompany Invoicing
Oracle Supply Chain Financial Orchestration Fusion Cloud provides the ability to import external trade events in bulk for processing intercompany transactions from Oracle subscriptions or external sources to generate intercompany receivables and payables invoices using transfer pricing rules.
You can use the REST resource client to import a single record or multiple records for external trade flows. The supply chain controller works with other users to bring in these trade transactions and prepares the data for importing them into supply chain financial orchestration.
Here's a typical application processing flow for the scenario:
- In this example, you have multiple trade transactions for an item referencing different source documents that you want to import. You can use the POST service of the Financial Orchestration Source Transaction Event resource by giving the header details of the transaction such as Source Document Identifier, Creation Date, Order Number, Oder Line Number, Ship from and Ship to organization details, and Provider and Receiver BUs.
- Provider and Receiver BUs should be profit center BUs.
- Business units should be associated with organizations in Manage Inventory Organizations.
- Item should be associated with the Ship From organization in Manage Items.
- Passing related transaction level details to the child resource, Financial Orchestration Source Transaction Event Logs, of the parent resource such as event number, event date, accounting date, quantity, unit of measure, unitcost, currency.
- You can also capture additional contextual details about the transaction in the attribute reference fields 1 to 15.
- The response payload includes details of records uploaded. As this is an offline process, the immediate response is always shown as NOT STARTED.
- You can get the list of External Trade Events transactions imported by calling the GET service of the financialOrchestrationSourceTransactionEvents resource for the request. You can get only External Trade Events that are not orchestrated yet and their status should be NOT_STARTED.
In this example, there's a sample payload to create an external trade event along with event order details.
Create an External Trade Event
Use this resource URL format.
POST
curl -u username:password -X POST -H "Content-Type:application/vnd.oracle.adf.resourceitem+json" -d 'request payload' "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents"
Example Request
Here's an example of the request body in JSON format. Source Document ID carries the unique identifier of the external trade event and it should be a numeric value. The Source Document ID links the external trade event with order details. In order to create and orchestrate an External Trade Event, SourceDocumentId, OrderCreationDate, OrderNumber, OrderLineNumber, ItemNumber, ProviderBusinessUnit, ReceiverBusinessUnit are mandatory attributes. The Provider and Receiver BU should be profit senter BUs. Business units should be associated with organizations in Manage Inventory Organizations. Am Item should be associated with ShipFromOrganization in Manage Items. If we don't provide shipfromorganization in the payload, then the application will pick from the Financial Orchestration Source System options (Item Validation Organization).
{
"SourceDocumentId" : 1000201,
"OrderCreationDate": "2024-08-21",
"OrderNumber": "EXTC20240821_201",
"OrderLineNumber": "1",
"ItemNumber": "AS92888",
"ProviderBusinessUnit": "Singapore Distribution Center",
"ReceiverBusinessUnit": "Vision Operations"
}
Example Response
- You can see shipfromorganization defaulted as V1 because Item Validation Organization is V1 in the Financial Orchestration Source system options:
Here's an example of the response body in JSON format.
{
"SourceDocumentId": "1000201",
"OrderCreationDate": "2024-08-21",
"OrderNumber": "EXTC20240821_201",
"OrderLineNumber": "1",
"ItemNumber": "AS92888",
"ShipFromOrganizationCode": "V1",
"ShipToOrganizationCode": null,
"ProviderBusinessUnit": "Singapore Distribution Center",
"ReceiverBusinessUnit": "Vision Operations",
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A6578700000000177040000000173
7200116A6176612E6C616E672E496E746567657212E2A0A4F781873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
},
{
"rel": "child",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379/child/TransactionEventLog",
"name": "TransactionEventLog",
"kind": "collection"
}
]
}
GET One External Trade Event
By using the GET operation, we can get only External Trade Events that aren't orchestrated yet. Their status should be NOT_STARTED. To get the created external trade event, we need to use the following URL, passing DocumentLogId.
GET
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/DocumentLogId"
For example:
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379"
Example Response
Here's an example of the response body in JSON format.
{
"SourceDocumentId": "1000201",
"OrderCreationDate": "2024-08-21",
"OrderNumber": "EXTC20240821_201",
"OrderLineNumber": "1",
"ItemNumber": "AS92888",
"ShipFromOrganizationCode": "V1",
"ShipToOrganizationCode": null,
"ProviderBusinessUnit": "Singapore Distribution Center",
"ReceiverBusinessUnit": "Vision Operations",
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200
116A6176612E6C616E672E496E746567657212E2A0A4F781873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
},
{
"rel": "child",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379/child/TransactionEventLog",
"name": "TransactionEventLog",
"kind": "collection"
}
]
}
Create External Trade Event Order Details
Use this resource URL format.
POST
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/DocInfoLogId/child/TransactionEventLog"
Example Request
Here's an example of the request body in JSON format. To create the Order Details, the following are the list of mandatory attributes such as EventNumber, EventDate, Quanity, UnitOfMeasure, UnitCost, Currency. If you provide AccountingDate, then Accounting date must be the same as the Event date or later than the Event date. DFF Attributes such as Attribites(1-15), AttrbutesNumbers(1-5), AttributeDate(1-3), AttributeTimestamp(1-3) provides the additional information and will be used as qualifier parameters and those are not mandatory.
{
"EventNumber": "EXTC20240821_201",
"EventDate": "2024-08-21T00:00:00+00:00",
"Quantity": 2,
"UnitOfMeasure": "Ea",
"UnitCost": 20,
"Currency": "SGD"
}
Example Response
Here's an example of the response body in JSON format.
{
"EventNumber": "EXTC20240821_201",
"EventDate": "2024-08-21T00:00:00+00:00",
"Quantity": 2,
"UnitOfMeasure": "Ea",
"UnitCost": 20,
"Currency": "SGD",
"AccountingDate": null,
"CountryOfOriginCode": null,
"ProjectNumber": null,
"AttributeChar1": null,
"AttributeChar2": null,
"AttributeChar3": null,
"AttributeChar4": null,
"AttributeChar5": null,
"AttributeChar6": null,
"AttributeChar7": null,
"AttributeChar8": null,
"AttributeChar9": null,
"AttributeChar10": null,
"AttributeChar11": null,
"AttributeChar12": null,
"AttributeChar13": null,
"AttributeChar14": null,
"AttributeChar15": null,
"AttributeDate1": null,
"AttributeDate2": null,
"AttributeDate3": null,
"AttributeNumber1": null,
"AttributeNumber2": null,
"AttributeNumber3": null,
"AttributeNumber4": null,
"AttributeNumber5": null,
"AttributeTimestamp1": null,
"AttributeTimestamp2": null,
"AttributeTimestamp3": null,
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379/child/TransactionEventLog/300100655759715",
"name": "TransactionEventLog",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E7465
67657212E2A0A4F781873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379/child/TransactionEventLog/300100655759715",
"name": "TransactionEventLog",
"kind": "item"
},
{
"rel": "parent",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
}
]
}
GET Event Order Details
By using GET operation,we can get only External Trade Events that are not orchestrated yet and their status should be NOT_STARTED.
To get the created external trade event order details, use this resource URL format by passing TransactionLogId.
GET
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/DocInfoLogId/child/TransactionEventLog/TransactionLogId"
For example:
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379/child/TransactionEventLog/300100655759715"
Example Response
Here's an example of the response body in JSON format.
{
"EventNumber": "EXTC20240821_201",
"EventDate": "2024-08-21T00:00:00+00:00",
"Quantity": 2,
"UnitOfMeasure": "Ea",
"UnitCost": 20,
"Currency": "SGD",
"AccountingDate": null,
"CountryOfOriginCode": null,
"ProjectNumber": null,
"AttributeChar1": null,
"AttributeChar2": null,
"AttributeChar3": null,
"AttributeChar4": null,
"AttributeChar5": null,
"AttributeChar6": null,
"AttributeChar7": null,
"AttributeChar8": null,
"AttributeChar9": null,
"AttributeChar10": null,
"AttributeChar11": null,
"AttributeChar12": null,
"AttributeChar13": null,
"AttributeChar14": null,
"AttributeChar15": null,
"AttributeDate1": null,
"AttributeDate2": null,
"AttributeDate3": null,
"AttributeNumber1": null,
"AttributeNumber2": null,
"AttributeNumber3": null,
"AttributeNumber4": null,
"AttributeNumber5": null,
"AttributeTimestamp1": null,
"AttributeTimestamp2": null,
"AttributeTimestamp3": null,
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379/child/TransactionEventLog/300100655759715",
"name": "TransactionEventLog",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E7465
67657212E2A0A4F781873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379/child/TransactionEventLog/300100655759715",
"name": "TransactionEventLog",
"kind": "item"
},
{
"rel": "parent",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100655755379",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
}
]
}
Create a Bulk Payload
In the example, there are three records for an item submitted to import.
Use this resource URL format.
POST
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents"
Example Request
Here's an example of the request body in JSON format. You plan to import three external trade events with source docuemnt ID(which is mandatory and should be numeric) 10001002, 10001003, and 10001004. In this example, all the attributes are given that are available to create the payload for the external trade event and event order details.
{
"parts": [
{
"id": "part1",
"path": "/financialOrchestrationSourceTransactionEvents",
"operation": "create",
"payload": {
"SourceDocumentId": "10001002",
"OrderCreationDate": "2024-08-20",
"OrderNumber": "EXTC20240820_1",
"OrderLineNumber": "1",
"ItemNumber": "AS92888",
"ShipFromOrganizationCode": "D1",
"ShipToOrganizationCode": "V1",
"ProviderBusinessUnit": "Singapore Distribution Center",
"ReceiverBusinessUnit": "Vision Operations",
"TransactionEventLog": [
{
"EventNumber": "EVT_EXTC20240820_1",
"EventDate": "2024-08-20T00:00:00+00:00",
"Quantity": 2,
"UnitOfMeasure": "Ea",
"UnitCost": 20,
"Currency": "SGD",
"AccountingDate": "2024-08-20T00:00:00+00:00",
"CountryOfOriginCode": "SG",
"ProjectNumber": null,
"AttributeChar1": null,
"AttributeChar2": "BBB",
"AttributeChar3": null,
"AttributeChar4": "aBC",
"AttributeChar5": "01/JAN/2024",
"AttributeChar6": "Sample Purpose",
"AttributeChar7": "sample",
"AttributeChar8": "01/06/2024 mm:dd:yy",
"AttributeChar9": "29/02/2014-053429 pm",
"AttributeChar10": "@",
"AttributeChar11": "abc",
"AttributeChar12": "ABC",
"AttributeChar13": "123",
"AttributeChar14": "PQR",
"AttributeChar15": "XYZ",
"AttributeDate1": "2024-06-01",
"AttributeDate2": "2023-05-02",
"AttributeDate3": "2022-04-03",
"AttributeNumber1": 123456789,
"AttributeNumber2": 123,
"AttributeNumber3": 456,
"AttributeNumber4": 123,
"AttributeNumber5": 5678,
"AttributeTimestamp1": "2024-06-05T10:25:36+00:00",
"AttributeTimestamp2": "2023-05-04T10:25:36+00:00",
"AttributeTimestamp3": "2023-05-04T00:00:36.123+00:00"
}
]
}
},
{
"id": "part2",
"path": "/financialOrchestrationSourceTransactionEvents",
"operation": "create",
"payload": {
"SourceDocumentId": "10001003",
"OrderCreationDate": "2024-08-20",
"OrderNumber": "EXTC20240820_2",
"OrderLineNumber": "1",
"ItemNumber": "AS92888",
"ShipFromOrganizationCode": "D1",
"ShipToOrganizationCode": "V1",
"ProviderBusinessUnit": "Singapore Distribution Center",
"ReceiverBusinessUnit": "Vision Operations",
"TransactionEventLog": [
{
"EventNumber": "EVT_EXTC20240820_2",
"EventDate": "2024-08-20T00:00:00+00:00",
"Quantity": 2,
"UnitOfMeasure": "Ea",
"UnitCost": 20,
"Currency": "SGD",
"AccountingDate": "2024-08-16T00:00:00+00:00",
"CountryOfOriginCode": "SG",
"ProjectNumber": null,
"AttributeChar1": null,
"AttributeChar2": "BBB",
"AttributeChar3": null,
"AttributeChar4": "aBC",
"AttributeChar5": "01/JAN/2024",
"AttributeChar6": "Sample Purpose",
"AttributeChar7": "sample",
"AttributeChar8": "01/06/2024 mm:dd:yy",
"AttributeChar9": "29/02/2014-053429 pm",
"AttributeChar10": "@",
"AttributeChar11": "abc",
"AttributeChar12": "ABC",
"AttributeChar13": "123",
"AttributeChar14": "PQR",
"AttributeChar15": "XYZ",
"AttributeDate1": "2024-06-01",
"AttributeDate2": "2023-05-02",
"AttributeDate3": "2022-04-03",
"AttributeNumber1": 123456789,
"AttributeNumber2": 123,
"AttributeNumber3": 456,
"AttributeNumber4": 123,
"AttributeNumber5": 5678,
"AttributeTimestamp1": "2024-06-05T10:25:36+00:00",
"AttributeTimestamp2": "2023-05-04T10:25:36+00:00",
"AttributeTimestamp3": "2023-05-04T00:00:36.123+00:00"
}
]
}
},
{
"id": "part3",
"path": "/financialOrchestrationSourceTransactionEvents",
"operation": "create",
"payload": {
"SourceDocumentId": "10001004",
"OrderCreationDate": "2024-08-20",
"OrderNumber": "EXTC20240820_3",
"OrderLineNumber": "1",
"ItemNumber": "AS92888",
"ShipFromOrganizationCode": "D1",
"ShipToOrganizationCode": "V1",
"ProviderBusinessUnit": "Singapore Distribution Center",
"ReceiverBusinessUnit": "Vision Operations",
"TransactionEventLog": [
{
"EventNumber": "EVT_EXTC20240820_3",
"EventDate": "2024-08-20T00:00:00+00:00",
"Quantity": 2,
"UnitOfMeasure": "Ea",
"UnitCost": 20,
"Currency": "SGD",
"AccountingDate": "2024-08-20T00:00:00+00:00",
"CountryOfOriginCode": "SG",
"ProjectNumber": null,
"AttributeChar1": null,
"AttributeChar2": "BBB",
"AttributeChar3": null,
"AttributeChar4": "aBC",
"AttributeChar5": "01/JAN/2024",
"AttributeChar6": "Sample Purpose",
"AttributeChar7": "sample",
"AttributeChar8": "01/06/2024 mm:dd:yy",
"AttributeChar9": "29/02/2014-053429 pm",
"AttributeChar10": "@",
"AttributeChar11": "abc",
"AttributeChar12": "ABC",
"AttributeChar13": "123",
"AttributeChar14": "PQR",
"AttributeChar15": "XYZ",
"AttributeDate1": "2024-06-01",
"AttributeDate2": "2023-05-02",
"AttributeDate3": "2022-04-03",
"AttributeNumber1": 123456789,
"AttributeNumber2": 123,
"AttributeNumber3": 456,
"AttributeNumber4": 123,
"AttributeNumber5": 5678,
"AttributeTimestamp1": "2024-06-05T10:25:36+00:00",
"AttributeTimestamp2": "2023-05-04T10:25:36+00:00",
"AttributeTimestamp3": "2023-05-04T00:00:36.123+00:00"
}
]
}
}
]
}
Example Response
- You can see three external trade events with the corresponding three event order details. The DocInfoLogId's are 300100612728822, 300100612728824, and 300100612728826. The corresponding TransactionLogId's are 300100612728823, 300100612728825, and 300100612728827.
-
- Order Deatils (TransactionLogId) 300100612728823 for External Trade Event (DocInfoLogID) 300100612728822
- Order Deatils (TransactionLogId) 300100612728825 for External Trade Event (DocInfoLogID) 300100612728824
- Order Deatils (TransactionLogId) 300100612728827 for External Trade Event (DocInfoLogID) 300100612728826
Here's an example of the response body in JSON format.
{
"parts": [
{
"id": "part1",
"path": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents",
"operation": "create",
"payload": {
"SourceDocumentId": "10001002",
"OrderCreationDate": "2024-08-20",
"OrderNumber": "EXTC20240820_1",
"OrderLineNumber": "1",
"ItemNumber": "AS92888",
"ShipFromOrganizationCode": "D1",
"ShipToOrganizationCode": "V1",
"ProviderBusinessUnit": "Singapore Distribution Center",
"ReceiverBusinessUnit": "Vision Operations",
"TransactionEventLog": [
{
"EventNumber": "EVT_EXTC20240820_1",
"EventDate": "2024-08-20T00:00:00+00:00",
"Quantity": 2,
"UnitOfMeasure": "Ea",
"UnitCost": 20,
"Currency": "SGD",
"AccountingDate": "2024-08-20T00:00:00+00:00",
"CountryOfOriginCode": "SG",
"ProjectNumber": null,
"AttributeChar1": null,
"AttributeChar2": "BBB",
"AttributeChar3": null,
"AttributeChar4": "aBC",
"AttributeChar5": "01/JAN/2024",
"AttributeChar6": "Sample Purpose",
"AttributeChar7": "sample",
"AttributeChar8": "01/06/2024 mm:dd:yy",
"AttributeChar9": "29/02/2014-053429 pm",
"AttributeChar10": "@",
"AttributeChar11": "abc",
"AttributeChar12": "ABC",
"AttributeChar13": "123",
"AttributeChar14": "PQR",
"AttributeChar15": "XYZ",
"AttributeDate1": "2024-06-01",
"AttributeDate2": "2023-05-02",
"AttributeDate3": "2022-04-03",
"AttributeNumber1": 123456789,
"AttributeNumber2": 123,
"AttributeNumber3": 456,
"AttributeNumber4": 123,
"AttributeNumber5": 5678,
"AttributeTimestamp1": "2024-06-05T10:25:36+00:00",
"AttributeTimestamp2": "2023-05-04T10:25:36+00:00",
"AttributeTimestamp3": "2023-05-04T00:00:36.123+00:00",
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728822/child/TransactionEventLog/300100612728823",
"name": "TransactionEventLog",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E746567657212E2A0
A4F781873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728822/child/TransactionEventLog/300100612728823",
"name": "TransactionEventLog",
"kind": "item"
},
{
"rel": "parent",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728822",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
}
]
}
],
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728822",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E746567657212E2A0A4F7818738
02000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728822",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
},
{
"rel": "child",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728822/child/TransactionEventLog",
"name": "TransactionEventLog",
"kind": "collection"
}
]
}
},
{
"id": "part2",
"path": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents",
"operation": "create",
"payload": {
"SourceDocumentId": "10001003",
"OrderCreationDate": "2024-08-20",
"OrderNumber": "EXTC20240820_2",
"OrderLineNumber": "1",
"ItemNumber": "AS92888",
"ShipFromOrganizationCode": "D1",
"ShipToOrganizationCode": "V1",
"ProviderBusinessUnit": "Singapore Distribution Center",
"ReceiverBusinessUnit": "Vision Operations",
"TransactionEventLog": [
{
"EventNumber": "EVT_EXTC20240820_2",
"EventDate": "2024-08-20T00:00:00+00:00",
"Quantity": 2,
"UnitOfMeasure": "Ea",
"UnitCost": 20,
"Currency": "SGD",
"AccountingDate": "2024-08-20T00:00:00+00:00",
"CountryOfOriginCode": "SG",
"ProjectNumber": null,
"AttributeChar1": null,
"AttributeChar2": "BBB",
"AttributeChar3": null,
"AttributeChar4": "aBC",
"AttributeChar5": "01/JAN/2024",
"AttributeChar6": "Sample Purpose",
"AttributeChar7": "sample",
"AttributeChar8": "01/06/2024 mm:dd:yy",
"AttributeChar9": "29/02/2014-053429 pm",
"AttributeChar10": "@",
"AttributeChar11": "abc",
"AttributeChar12": "ABC",
"AttributeChar13": "123",
"AttributeChar14": "PQR",
"AttributeChar15": "XYZ",
"AttributeDate1": "2024-06-01",
"AttributeDate2": "2023-05-02",
"AttributeDate3": "2022-04-03",
"AttributeNumber1": 123456789,
"AttributeNumber2": 123,
"AttributeNumber3": 456,
"AttributeNumber4": 123,
"AttributeNumber5": 5678,
"AttributeTimestamp1": "2024-06-05T10:25:36+00:00",
"AttributeTimestamp2": "2023-05-04T10:25:36+00:00",
"AttributeTimestamp3": "2023-05-04T00:00:36.123+00:00",
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728824/child/TransactionEventLog/300100612728825",
"name": "TransactionEventLog",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E746567657212E
2A0A4F781873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728824/child/TransactionEventLog/300100612728825",
"name": "TransactionEventLog",
"kind": "item"
},
{
"rel": "parent",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728824",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
}
]
}
],
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728824",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E746567657212E2A0A4F78
1873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728824",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
},
{
"rel": "child",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728824/child/TransactionEventLog",
"name": "TransactionEventLog",
"kind": "collection"
}
]
}
},
{
"id": "part3",
"path": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents",
"operation": "create",
"payload": {
"SourceDocumentId": "10001004",
"OrderCreationDate": "2024-08-20",
"OrderNumber": "EXTC20240820_3",
"OrderLineNumber": "1",
"ItemNumber": "AS92888",
"ShipFromOrganizationCode": "D1",
"ShipToOrganizationCode": "V1",
"ProviderBusinessUnit": "Singapore Distribution Center",
"ReceiverBusinessUnit": "Vision Operations",
"TransactionEventLog": [
{
"EventNumber": "EVT_EXTC20240820_3",
"EventDate": "2024-08-20T00:00:00+00:00",
"Quantity": 2,
"UnitOfMeasure": "Ea",
"UnitCost": 20,
"Currency": "SGD",
"AccountingDate": "2024-08-20T00:00:00+00:00",
"CountryOfOriginCode": "SG",
"ProjectNumber": null,
"AttributeChar1": null,
"AttributeChar2": "BBB",
"AttributeChar3": null,
"AttributeChar4": "aBC",
"AttributeChar5": "01/JAN/2024",
"AttributeChar6": "Sample Purpose",
"AttributeChar7": "sample",
"AttributeChar8": "01/06/2024 mm:dd:yy",
"AttributeChar9": "29/02/2014-053429 pm",
"AttributeChar10": "@",
"AttributeChar11": "abc",
"AttributeChar12": "ABC",
"AttributeChar13": "123",
"AttributeChar14": "PQR",
"AttributeChar15": "XYZ",
"AttributeDate1": "2024-06-01",
"AttributeDate2": "2023-05-02",
"AttributeDate3": "2022-04-03",
"AttributeNumber1": 123456789,
"AttributeNumber2": 123,
"AttributeNumber3": 456,
"AttributeNumber4": 123,
"AttributeNumber5": 5678,
"AttributeTimestamp1": "2024-06-05T10:25:36+00:00",
"AttributeTimestamp2": "2023-05-04T10:25:36+00:00",
"AttributeTimestamp3": "2023-05-04T00:00:36.123+00:00",
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728826/child/TransactionEventLog/300100612728827",
"name": "TransactionEventLog",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E746567657212E
2A0A4F781873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728826/child/TransactionEventLog/300100612728827",
"name": "TransactionEventLog",
"kind": "item"
},
{
"rel": "parent",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728826",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
}
]
}
],
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728826",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E746567657212E2A0A4F781
873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000178"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728826",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
},
{
"rel": "child",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100612728826/child/TransactionEventLog",
"name": "TransactionEventLog",
"kind": "collection"
}
]
}
}
]
}
Update an External Trade Event
We can update only those External Trade Events that are not Orchestrated yet.
Use this resource URL format.
PATCH
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/DocInfoLogId"
For example:
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666028118"
Example Request
While updating External Trade Event Details, the following should be taken care of:
- Source Document ID carries the unique identifier of the external trade event, it should not be updated. Also Source Document ID links the external trade event with order details.
- Apart from SourceDocumentId, we can update the following attributes like OrderCreationDate, OrderNumber, OrderLineNumber, ItemNumber, ProviderBusinessUnit, ReceiverBusinessUnit, ShipFromOrganization, ShipToOrganization.
- If we update shipfromorganization with "null" in the payload, then it will pick from Financial Orchestration Source System options (Item Validation Organization).
- While updating any business units (BUs), we must make sure that the updated BU should be a Profit Center BU and must be associated with corresponding organization in Manage Inventory Organizations. Same association must be checked while updating organizations.
- While updating the item, we must make sure that the updated item is associated with ShipFromOrganization in Manage Items.
Here's an example of the request body in JSON format.
{
"OrderNumber": "EXTC20241028_2",
"OrderLineNumber": "2",
"ItemNumber": "FOS-DS-002",
"ProviderBusinessUnit": "FOS_VisSGD_Shp_BU",
"ReceiverBusinessUnit": "FOS_VisOP_Sel_BU",
"ShipFromOrganizationCode": "FOSVISSGDINVORG5",
"ShipToOrganizationCode": "FOSVISOPINVORG6"
}
Example Response
Here's an example of the response body in JSON format.
{
"SourceDocumentId": "3030102801",
"OrderCreationDate": "2024-10-28",
"OrderNumber": "EXTC20241028_2",
"OrderLineNumber": "2",
"ItemNumber": "FOS-DS-002",
"ShipFromOrganizationCode": "FOSVISSGDINVORG5",
"ShipToOrganizationCode": "FOSVISOPINVORG6",
"ProviderBusinessUnit": "FOS_VisSGD_Shp_BU",
"ReceiverBusinessUnit": "FOS_VisOP_Sel_BU",
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666028118",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E746567657212E2A0A4F781
873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000278"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666028118",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
},
{
"rel": "child",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666028118/child/TransactionEventLog",
"name": "TransactionEventLog",
"kind": "collection"
}
]
}
Update External Trade Event Order Details
We can update attributes such as EventNumber, EventDate, Quantity, UnitOfMeasure, UnitCost, Currency, AccountingDate, CountryOfOriginCode, ProjectNumber, AttributeChar (1-15), AttributeNumber (1-5), AttributeDate (1-3), and AttributeTimeStamp (1-3). While updating AccountingDate or EventDate, we should take care of Accounting date must be the same as the Event date or later than the Event date.
Use this resource URL format.
PATCH
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/DocInfoLogId/child/TransactionEventLog/TransactionLogId"
For example:
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666028118/child/TransactionEventLog/300100666028119"
Example Request
Here's an example of the request body in JSON format.
{
"EventNumber": "EXTC20241028_2",
"Quantity": 100,
"UnitOfMeasure": "Ea",
"UnitCost": 10,
"Currency": "USD",
"ProjectNumber": null,
"AttributeChar1": "test1",
"AttributeChar4": "test4",
"AttributeChar14": "Sample1",
"AttributeNumber1": 123,
"AttributeNumber4": 345
}
Example Response
Here's an example of the response body in JSON format.
{
"EventNumber": "EXTC20241028_2",
"EventDate": "2024-10-28T00:00:00+00:00",
"Quantity": 100,
"UnitOfMeasure": "Ea",
"UnitCost": 10,
"Currency": "USD",
"AccountingDate": "2024-10-28T00:00:00+00:00",
"CountryOfOriginCode": "US",
"ProjectNumber": null,
"AttributeChar1": "test1",
"AttributeChar2": null,
"AttributeChar3": null,
"AttributeChar4": "test4",
"AttributeChar5": null,
"AttributeChar6": null,
"AttributeChar7": null,
"AttributeChar8": null,
"AttributeChar9": null,
"AttributeChar10": null,
"AttributeChar11": null,
"AttributeChar12": null,
"AttributeChar13": null,
"AttributeChar14": "Sample1",
"AttributeChar15": null,
"AttributeDate1": null,
"AttributeDate2": null,
"AttributeDate3": null,
"AttributeNumber1": 123,
"AttributeNumber2": null,
"AttributeNumber3": null,
"AttributeNumber4": 345,
"AttributeNumber5": null,
"AttributeTimestamp1": null,
"AttributeTimestamp2": null,
"AttributeTimestamp3": null,
"links": [
{
"rel": "self",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666028118/child/TransactionEventLog/300100666028119",
"name": "TransactionEventLog",
"kind": "item",
"properties": {
"changeIndicator": "ACED0005737200136A6176612E7574696C2E41727261794C6973747881D21D99C7619D03000149000473697A65787000000001770400000001737200116A6176612E6C616E672E496E74656
7657212E2A0A4F781873802000149000576616C7565787200106A6176612E6C616E672E4E756D62657286AC951D0B94E08B02000078700000000278"
}
},
{
"rel": "canonical",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666028118/child/TransactionEventLog/300100666028119",
"name": "TransactionEventLog",
"kind": "item"
},
{
"rel": "parent",
"href": "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666028118",
"name": "financialOrchestrationSourceTransactionEvents",
"kind": "item"
}
]
}
Delete External Trade Event Details
We can delete only those External Trade Events that are not orchestrated yet.
Use this resource URL format.
DELETE
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/DocInfoLogId"
For example:
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666028118/"
Example Response
Here's an example of the response body in JSON format.
204 No Content
Delete External Trade Event Order Details
We can delete only those External Trade Events Orders which are not Orchestrated yet. Even if we delete Order details, External Trade Events will remain.
Use this resource URL format.
DELETE
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/DocInfoLogId/child/TransactionEventLog/TransactionLogId"
For example:
curl -u username:password "https://servername/fscmRestApi/resources/version/financialOrchestrationSourceTransactionEvents/300100666120657/child/TransactionEventLog/300100666120658"
Example Response
Here's an example of the response body in JSON format.
204 No Content